package xyz.lychee.lagfixer.libs.adventure.pointer;

import java.util.function.Function;
import xyz.lychee.lagfixer.libs.adventure.builder.AbstractBuilder;
import xyz.lychee.lagfixer.libs.annotations.Contract;
import xyz.lychee.lagfixer.libs.annotations.NotNull;
import xyz.lychee.lagfixer.libs.annotations.Nullable;

public interface PointersSupplier<T> {
   @NotNull
   static <T> @NotNull Builder<T> builder() {
      return new PointersSupplierImpl.BuilderImpl();
   }

   @NotNull Pointers view(final @NotNull T instance);

   <P> boolean supports(final @NotNull Pointer<P> pointer);

   <P> @Nullable Function<? super T, P> resolver(final @NotNull Pointer<P> pointer);

   public interface Builder<T> extends AbstractBuilder<PointersSupplier<T>> {
      @Contract("_ -> this")
      @NotNull
      @NotNull Builder<T> parent(final @Nullable PointersSupplier<? super T> parent);

      @Contract("_, _ -> this")
      @NotNull
      <P> @NotNull Builder<T> resolving(final @NotNull Pointer<P> pointer, final @NotNull Function<T, P> resolver);
   }
}
